"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
var execa = require("execa");
var fs = require("fs-extra");
var globby = require("globby");
var path = require("path");
var readPkg = require("read-pkg");
var writePkg = require("write-pkg");
var dependencies = [
    "typescript",
    "tslint",
];
var isWin = process.platform === "win32";
var npmBinRegExp = isWin
    ? /[\\/]np[mx](\.cmd)?$/
    : /\/np[mx]$/;
var npmJsRegExp = isWin
    ? /[\\/]node_modules[\\/]npm[\\/]bin[\\/]np[mx]-cli\.js$/
    : /\/node_modules\/npm\/bin\/np[mx]-cli\.js$/;
function install(cwd) {
    return __awaiter(this, void 0, void 0, function () {
        var bin;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, findBin()];
                case 1:
                    bin = _a.sent();
                    return [4 /*yield*/, initPackage(bin, cwd)];
                case 2:
                    _a.sent();
                    return [4 /*yield*/, installDependencies(bin, cwd)];
                case 3:
                    _a.sent();
                    return [4 /*yield*/, writePackageScripts(cwd)];
                case 4:
                    _a.sent();
                    return [4 /*yield*/, initFiles(cwd)];
                case 5:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
}
exports.install = install;
function checkBin(bin) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            return [2 /*return*/, !execa.sync(bin, ["-v"], {
                    reject: false,
                }).failed];
        });
    });
}
function findBin() {
    return __awaiter(this, void 0, void 0, function () {
        var env, bin;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    env = process.env;
                    bin = "yarn";
                    if (npmJsRegExp.test(env.NPM_CLI_JS) ||
                        npmJsRegExp.test(env.NPX_CLI_JS) ||
                        npmBinRegExp.test(env._)) {
                        bin = "npm";
                    }
                    return [4 /*yield*/, checkBin(bin)];
                case 1:
                    if (!!(_a.sent())) return [3 /*break*/, 3];
                    bin = bin === "yarn" ? "npm" : "yarn";
                    return [4 /*yield*/, checkBin(bin)];
                case 2:
                    if (!(_a.sent())) {
                        throw new Error("No package manager found.");
                    }
                    _a.label = 3;
                case 3: return [2 /*return*/, bin];
            }
        });
    });
}
function initPackage(bin, cwd) {
    return __awaiter(this, void 0, void 0, function () {
        var initArgs, binArgs;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    initArgs = process.argv
                        .slice(2)
                        .filter(function (arg) { return arg.startsWith("-"); });
                    binArgs = __spread([
                        "init"
                    ], initArgs);
                    return [4 /*yield*/, execa(bin, binArgs, { cwd: cwd, stdio: "inherit" })];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
}
function installDependencies(bin, cwd) {
    return __awaiter(this, void 0, void 0, function () {
        var args;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    args = bin === "yarn"
                        ? __spread(["add"], dependencies) : __spread(["i", "--save"], dependencies);
                    return [4 /*yield*/, execa(bin, args, { cwd: cwd })];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
}
function writePackageScripts(cwd) {
    return __awaiter(this, void 0, void 0, function () {
        var pkg;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, readPkg(cwd)];
                case 1:
                    pkg = _a.sent();
                    return [4 /*yield*/, writePkg(cwd, __assign({}, pkg, { files: [
                                "./bin/*",
                                "./lib/*",
                            ], main: "./lib/index.js", typings: "./lib/index.d.ts", scripts: __assign({}, pkg.scripts, { build: "tsc", lint: "tslint -c tslint.json src/**/*.ts", prepublish: "npm run build" }), _id: undefined, readme: undefined }))];
                case 2:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
}
function initFiles(cwd) {
    return __awaiter(this, void 0, void 0, function () {
        var filesFromThisProject, filesFromTemplate;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    filesFromThisProject = [
                        "tsconfig.json",
                    ];
                    filesFromTemplate = [
                        ".gitignore",
                        "tslint.json",
                        "README.md",
                        "src/*",
                    ];
                    return [4 /*yield*/, Promise.all([
                            copyFiles(filesFromThisProject, path.join(__dirname, ".."), cwd),
                            copyFiles(filesFromTemplate, path.join(__dirname, "../template"), cwd),
                        ])];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
}
function copyFiles(files, from, to) {
    return __awaiter(this, void 0, void 0, function () {
        var _this = this;
        var expandedFiles;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, globby(files, { cwd: from })];
                case 1:
                    expandedFiles = _a.sent();
                    return [4 /*yield*/, Promise.all(expandedFiles.map(function (file) { return __awaiter(_this, void 0, void 0, function () {
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0: return [4 /*yield*/, fs.mkdirp(path.dirname(path.join(to, file)))];
                                    case 1:
                                        _a.sent();
                                        return [4 /*yield*/, fs.copy(path.join(from, file), path.join(to, file))];
                                    case 2:
                                        _a.sent();
                                        return [2 /*return*/];
                                }
                            });
                        }); }))];
                case 2:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
}
